#pragma once

///////////////////////////////////////////////////////////////////////////////
// Cliente HTTP de la libreria CURL.
//
// Para compilar es necesario aadir al proyecto la definicin del flag
// CURL_STATICLIB, si se quiere compilar estticamente.
// Y a la hora de linkar son necesarias las siguientes librerias:
//	
//		- winmm.lib
//		- curllibd.lib
//		- Wldap32.lib
// 
///////////////////////////////////////////////////////////////////////////////

//#include <curl/curl.h>
#include <curl_7.20.1/curl.h>

class CMyHTTPClientCURL
{
public:
	CMyHTTPClientCURL(void);
	~CMyHTTPClientCURL(void);

	// Constantes del HTTPClient
	static const int DEFAULT_HTTPCURL_CONNECT_TIMEOUT = 7000;

	// Son las mismas llamadas que habia en el CHTTPSession
	int OpenSession(LPCTSTR strDirIp, USHORT uPort, LPCTSTR strUsername, LPCTSTR strPassword, UINT uiMsTimeout = DEFAULT_HTTPCURL_CONNECT_TIMEOUT);
	int CloseSession();
	
	int Request(LPCTSTR szPath, UINT uiMsTimeout = DEFAULT_HTTPCURL_CONNECT_TIMEOUT);
	void CloseRequest();

	virtual int HttpReadResponse(CString &strResponse);
	virtual int Read(BYTE *pBuffer,UINT uLenMax)
	{
		int iLen=(m_stChunk.size<uLenMax)?m_stChunk.size:uLenMax;
		memcpy(pBuffer,m_stChunk.memory,iLen);
		return iLen;
	};

	// El error de la CURL
	DWORD GetLastCURLError() { return m_dwLastHttpError; };

	

protected:
	// Obtencin de los carateres HTML en memoria
	struct MemoryStruct 
	{
		char *memory;
		size_t size;
	};

	// Funcion de callback para obtener la respuesta HTML
	static size_t WriteMemoryCallback(void *ptr, size_t size, size_t nmemb, void *data);
	static void *myrealloc(void *ptr, size_t size);

private:
	// Reset response
	void ResetResponse();

private:
	// Objeto CURL del cliente HTTP
	CURL		*m_pCURL;

public:
	// Datos de la conexion HTTP
	CString		m_sAddress;
	int			m_iPort;
	CString	    m_strUsername;
	CString	    m_strPassword;

	// Contenido de la respuesta HTTP.
	struct MemoryStruct m_stChunk;
	char		*m_pReadPosition;


	// Ultimo error ocurrido (HTTP o CURLError)
	DWORD		m_dwLastHttpError;
};
